const pkg = require(`../package.json`);
const imagemin = require(`imagemin`);
const imageminMozjpeg = require('imagemin-mozjpeg');
const imageminPngquant = require(`imagemin-pngquant`);
const fs = require(`fs`);
const async = require(`async`);

const folder = `img/`;

const getFolders = (folder) => {
  fs.readdir(folder, (err, files) => {
    if (err) {
      throw err;
    }
    async.each(files, (i) => {
      if (!/\./.test(i)) {
        getFolders(`${folder}${i}/`);
        imageMin(`${folder}${i}/`);
      }
    });
  });
};

const imageMin = (folder) => {
  imagemin([`${folder}*.png`, `${folder}*.jpg`], folder, {
    plugins: [imageminMozjpeg({ quality: 60 }), imageminPngquant({ quality: `65-80` })],
  }).then((files) => {
    console.log(`imagemin: -> ${folder}`);
  });
};

getFolders(folder);
imageMin(folder);
