let pkg = require(`../package.json`);
const replace = require(`replace`);
const fs = require(`fs`);

const arrPwd = __dirname.split(`/`);
const directoryName = arrPwd[arrPwd.length - 2];

let oldName;
let replaceFileName = [];
let jsmodFileName;
let err;

if (pkg.name === directoryName) {
  console.log(`no replacing`);
  return;
}

oldName = pkg.name;

replaceFileName = [`./html/conf.html`, `./package.json`, `./webpack.config.js`];

try {
  jsmodFileName = fs.readdirSync(`./js/src/`);
} catch (e) {
  err = true;
}
if (err) {
  console.log(`there is no js`);
} else {
  for (let i = 0; i < jsmodFileName.length; i++) {
    replaceFileName.push(`./js/src/${jsmodFileName[i]}`);
  }
}

for (let i = 0; i < replaceFileName.length; i++) {
  replace({
    regex: pkg.name,
    replacement: directoryName,
    paths: [replaceFileName[i]],
    recursive: true,
    silent: true,
  });
}

fs.rename(`./sass/${oldName}.scss`, `./sass/${directoryName}.scss`, function (err) {
  if (err !== null) {
    console.log(`there is no scss`);
  }
});

const del = function (filePath) {
  try {
    fs.unlinkSync(filePath);
    return true;
  } catch (err) {}
};
del(`./dest/${oldName}.js`);
del(`./dest/${oldName}.css`);

pkg.name = directoryName;

console.log(`replaced: ${oldName} -> ${directoryName}`);
