const pkg = require(`../package.json`);
const Spritesmith = require(`spritesmith`);
const fs = require(`fs`);
const aPath = require(`path`);
const getFolders = (dir) => {
  return fs.readdirSync(dir).filter((file) => {
    return fs.statSync(aPath.join(dir, file)).isDirectory();
  });
};

const basePath = `sass/make/spr/param/_base.scss`;
//const rdm = (new Date()).getTime();

let baseData = new String();
let imgPath;
let writePath;
let filePath;
let file;
let property;
let x;
let y;
let xx;
let yy;
let w;
let h;
let W;
let H;
let img;
let folder;
let pngs;
let sprData;
let sprPath;
let filenameList;
let filenameParam;

const writeBase = (str) => {
  fs.writeFileSync(basePath, str);
};

fs.readdir(`sprite/`, (err, folders) => {
  if (err) {
    writeBase(`$spr: null;\n`);
  } else {
    baseData += `$spr: (`;
    for (let i = 0; i < folders.length; i++) {
      baseData += `$spr-${i}, `;
    }
    baseData += `);\n`;
    writeBase(baseData);
  }
});

const folders = getFolders(`sprite/`);
folders.forEach((value, index) => {
  fs.readdir(`sprite/${value}/`, (err, files) => {
    if (err) {
      writeBase(`$spr: null;\n`);
      return;
    } else {
      pngs = [];
      for (let i in files) {
        if (/\.png$/.test(files[i])) {
          pngs[i] = `sprite/${value}/${files[i]}`;
        }
      }

      Spritesmith.run(
        {
          src: pngs,
          algorithm: `binary-tree`,
          padding: 6,
        },
        (handleResult = (err, result) => {
          sprData = new String();
          sprPath = `sass/make/spr/_spr_${value}.scss`;

          if (result.properties.width === 0 && result.properties.height === 0) {
            fs.appendFileSync(sprPath, `$spr-${index}: null;\n`);
            return;
          }

          filenameList = [];
          filenameParam = ``;

          //imgPath = `img_org/make/spr-${value}-${rdm}.png`;
          //writePath = `img/make/spr-${value}-${rdm}.png`;
          imgPath = `img_org/make/spr-${value}.png`;
          writePath = `img/make/spr-${value}.png`;

          fs.writeFileSync(imgPath, result.image);

          for (let n in result.coordinates) {
            filePath = n.split(`/`);
            file = filePath[2].split(`.`)[0];
            property = `$${value}-${file}: (`;
            x = `${result.coordinates[n].x}px, `;
            y = `${result.coordinates[n].y}px, `;
            xx = `-${x}`;
            yy = `-${y}`;
            w = `${result.coordinates[n].width}px, `;
            h = `${result.coordinates[n].height}px, `;
            W = `${result.properties.width}px, `;
            H = `${result.properties.height}px, `;
            img = `'${writePath}', `;
            folder = `'${value}-${file}', );\n`;

            sprData += property + x + y + xx + yy + w + h + folder;

            filenameList.push(file);
          }

          for (let i = 0; i < filenameList.length; i++) {
            filenameParam = `${filenameParam}$${value}-${filenameList[i]}, `;
          }

          sprData += `$spr-${index}-sprites: (${filenameParam});\n`;
          sprData += `$spr-${index}: (${W}${H}${img}$spr-${index}-sprites, );\n`;

          fs.appendFileSync(sprPath, sprData);
        })
      );
    }
  });
});
