# project information 

## php server

```
$ php -S 127.0.0.1:8888 -t={workspace}
```


## install package

```
$ npm install
```


## run scripts 

```
$ npm run l // compile css, js

$ npm run i // make sprite, base64, imagemin 
$ npm run w // watch, livereload
$ npm run r // minify css, js
```


## imagemin usage

```
project/  
│  
├ img/  // <- don't touch
└ img_org/  // <- put images here
```
  

## sprite usage

```
project/  
│  
├ html/  
├ sass/  
│  ├ project.scss  
│  ├ _conf.scss  
│  └ src/  
│      ├ mod/  
│      │   ├ _base.scss  
│      │   └ _module.scss  
│      └ lib/  
│          ├ _reset.scss  
│          └ _utility.scss  
└ sprite/  
    ├ {foldername}/  
    │   ├ {filename}.png  
    │   └ {filename}.png  
    └ {foldername}/  
        ├ {filename}.png  
        └ {filename}.png  
  
// scss  
// @extend %spr-{foldername}-{filename} // 100%  
// @extend %spr-r2-{foldername}-{filename} // 50%  
// @extend %spr-r3-{foldername}-{filename} // 33.3%  
```


## base64 usage

```
project/  
│  
├ base64/  
│  ├ {filename}.png  
│  └ {filename}.png  
├ html/  
└ sass/  
     ├ project.scss  
     ├ _conf.scss  
     └ src/  
         ├ mod/  
         │   ├ _base.scss  
         │   └ _module.scss  
         └ lib/  
             ├ _reset.scss  
             └ _utility.scss  

// scss  
// @extend %base64-{filename} // 100%  
// @extend %base64-r2-{filename} // 50%  
// @extend %base64-r3-{filename} // 33.3%  
```
