const path = require('path');
const LicenseInfoWebpackPlugin = require('license-info-webpack-plugin').default;
const VueLoaderPlugin = require('vue-loader/lib/plugin');

module.exports = {

    entry: {
        'temp_npm': './js/src/main.js',
    },

    output: {
        path: path.join(__dirname, 'dest'),
        filename: '[name].js'
    },

    module: {
        rules: [
          {
              test: /\.js$/,
              exclude: /\/node_modules\//,
              use: [
                  {
                      loader: 'babel-loader',
                      options: {
                          presets: [
                              [
                                  '@babel/preset-env',
                              ],
                          ],
                      },
                  },
              ],
          },
          {
              loader: 'eslint-loader',
              enforce: 'pre',
              test: /\.js$/,
              exclude: /node_modules/,
              options: {
                configFile: '.eslintrc.js',
              },
          },
          {
            test: /\.vue$/,
            loader: 'vue-loader'
          },
          {
            test: /\.scss$/,
            use: [
                {
                    loader: 'style-loader',
                },
                {
                    loader: 'css-loader',
                },
                {
                    loader: 'sass-loader',
                },
            ],
          },
        ],
    },

    plugins: [
        new LicenseInfoWebpackPlugin({
            glob: '{LICENSE,license,License}*',
        }),
        new VueLoaderPlugin(),
    ],

    resolve: {
        alias: {
            vue: 'vue/dist/vue.js'
        }
    },

};

